<?php

class stwc_settings
{
    //const UPGRADE_URL = 'https://stwc.syncly.it/pricing';
    const  UPGRADE_URL = 'admin.php?page=stwc-home-pricing' ;
    const  UPGRADE_HTML = ' <span id="upgrade"><a href="' . self::UPGRADE_URL . '">👉 Upgrade</a></span>' ;
    const  STWC_SUPPORT_URL = 'https://discord.gg/TA7pm6dbzk' ;
    private  $settings_options ;
    public function __construct()
    {
        //add_action( 'admin_head', 'wpso_add_admin_custom_css', 10, 2 );
        add_action( 'admin_menu', array( $this, 'settings_add_plugin_page' ) );
        add_action( 'admin_init', array( $this, 'settings_page_init' ) );
    }
    
    public function settings_add_plugin_page()
    {
        add_menu_page(
            'Smart Tools for WooCommerce',
            // page_title
            'Smart Tools 4 WC ',
            // menu_title
            'manage_options',
            // capability
            'stwc-home',
            // menu_slug
            array( $this, 'create_about_page' ),
            // function
            STWC_URL . 'admin/images/stwc-icon.svg',
            // icon_url
            58
        );
        add_submenu_page(
            'stwc-home',
            // parent_slug
            'About STWC',
            //page_title
            'About STWC',
            // menu_title
            'manage_options',
            // capability
            'stwc-home',
            // menu_slug
            'create_about_page'
        );
        add_submenu_page(
            'stwc-home',
            // parent_slug
            'Bulk Coupons',
            //page_title
            '<span style="color: rgb(0, 171, 240);">Bulk Coupons</span>',
            // menu_title
            'manage_options',
            // capability
            'stwc-bulk',
            // menu_slug
            array( $this, 'create_bulk_page' )
        );
        add_submenu_page(
            'stwc-home',
            // parent_slug
            'Basic Tools',
            //page_title
            'Basic Tools',
            // menu_title
            'manage_options',
            // capability
            'stwc-free',
            // menu_slug
            array( $this, 'create_free_page' )
        );
        add_submenu_page(
            'stwc-home',
            // parent_slug
            'Upgrade Deal',
            //page_title
            '<strong style="color: #FCB214;">👉 Upgrade Deal</strong>',
            // menu_title
            'manage_options',
            // capability
            'stwc-deal',
            // menu_slug
            array( $this, 'create_deal_page' )
        );
    }
    
    /*
    function wpso_add_admin_custom_css() {
    	$log  = "2 - " . $text;	    
        file_put_contents(STWC_PATH . './log_'.date("j.n.Y").'.txt', $log, FILE_APPEND);
    
        ?>
        <!-- debug -->
        <style type="text/css">
    		#wpadminbar {
    		    background-color : #f1f1f1;
    		}	    
            #wpcontent {background-color: #f0f0f0; }
        </style>
        <?php
    }	
    */
    public function create_about_page()
    {
        ?>
		<link href="<?php 
        echo  STWC_URL ;
        ?>/admin/css/style.css" rel="stylesheet" type="text/css">
		<link href="<?php 
        echo  STWC_URL ;
        ?>/admin/css/bootstrap.min.css" rel="stylesheet" type="text/css">

		<div class="wrap">					
			<div class="container" style="max-width: 100%;">
			  <div class="row">
			    <div class="col-9" style="background-color: #f1f1f1 !important; border:solid 1px #3550a0;">
			    	<h2>Smart Tools for WooCommerce</h2>	

					<p>This is an index page to let you access the right tool conveniently. You see the 10 tools subdivided in the relative 3 tiers: free, business and professional. Also check the deal page for an exclusive upgrade offer. This plug-in is quite simple but solves different specific functions, if you have feedback to share please visit the support page on the right.</p>

					<h3>Basic Tools (<i>free</i>) <a class="btn btn-primary" href="admin.php?page=stwc-free" role="button">Go To Basic Tools</a></h3>

					<div class="container" style="max-width: 100%;">
					  <div class="row">
					    <div class="col">
					      <h5>Out of Stock Notice</h5>
					      <p>Add a notice when a product with stock management is out of stock, you can use this to put pressure on customers and show them that your products actually sell. Works great when you show low stock quantities.</p>
					    </div>
					    <div class="col">
					      <h5>Display Discount Percentage</h5>
					      <p>Display the % of price reduction of an item. For items with variants, show the max percentage inside the item. We had good results using this instead of the 'On Sale' badge, as numbers draws more attention.</p>
					    </div>
					    <div class="col">
					      <h5>Removes the <i>On Sale</i> Badge</h5>
					      <p>Removes the 'on sale' badge on discounted items. You can use this in combination with <i>Display Discount Percentage</i> to tell your customers the product is on sale and by how much is the discount.</p>
					    </div>
					    <div class="col">
					      <h5>Price Shortcode by ID</h5>
					      <p>Allow you to use WooCommerce shortcode to show the item price, looking it up by item ID. It may sound something really trivial, but we had quite a few requests for this from our e-commerce customers.</p>
					    </div>					    
					  </div>
					</div>		

					<h3>Pro Tools <?php 
        
        if ( stw_fs()->is_plan( 'Free', true ) ) {
            ?>
							<a class="btn btn-secondary disabled" href="#" role="button">Go To Pro Tools</a> <?php 
            echo  stwc_settings::UPGRADE_HTML ;
            ?>
						<?php 
        }
        
        ?></h3>						

					<div class="container" style="max-width: 100%;">
					  <div class="row">
					    <div class="col">
					      <h5>Add Custom Column</h5>
					      <p>Add one custom column on your backend (we will be extending this, <a href="<?php 
        echo  stwc_settings::STWC_SUPPORT_URL ;
        ?>" target="_blank">check the roadmap</a> in discord channel), that will show a specific product taxonomy. You can use this to show any data that is important to you.</p>
					    </div>
					    <div class="col">
					      <h5>Skip Cart Page (<i>Buy Now</i>)</h5>
					      <p>Turn your store in a superfast converting machine. Skip the cart page and deliver the customer to the payment page whenever he adds and item to the cart. Useful when customers usually buy only one item.<p>
					    </div>
					    <div class="col">
					      <h5>Send Email on Cancelled Orders</h5>
					      <p>Send the customer an email whenever the order is cancelled or failed. You can customize the WooCommerce email templates for further customization.</p>
					    </div>			    
					  </div>

					  <div class="row" style="padding-top:10px;">
					    <div class="col">
					      <h5>Add GDPR Compliant Checkbox</h5>
					      <p>Show a <u>really GDPR-compliant</u> checkbox on payment page, just after the terms & conditions. This is an evergreen request for customers located in the EU, as you may guess.</p>
					    </div>
					    <div class="col">
					      <h5>Auto Membership</h5>
					      <p>Set a user role upon specific item purchase (<a href="<?php 
        echo  stwc_settings::STWC_SUPPORT_URL ;
        ?>" target="_blank">check the roadmap</a> about how we plan to extend it). For a specific product, it will change the role from 'customer' to the role that you set.</p>
					    </div>
					    <div class="col">
					      <h5>Add P.IVA / VAT to Billing</h5>
					      <p>Add one (yes, we will be <a href="<?php 
        echo  stwc_settings::STWC_SUPPORT_URL ;
        ?>" target="_blank">extending this</a> too :) extra field to your customer billing details, confirmation email and in your backend. Usually VAT number is a really popular request.</p>
					    </div>			    
					  </div>					  
					</div>																												
			    </div>

			    <!-- right sidebar -->
			    <div class="col-3">
			    	<div class="container" style="max-width: 100%;">
			    		<div class="row">
			    			<div class="col-6" style="text-align:right;border-right: solid 1px #1d1d1d;">
			      				<p><strong>Author:</strong></p>			      							      							      				      			
			      			</div>

			    			<div class="col-6" style="text-align:left;">
			    				<p><a href="https://www.linkedin.com/in/stefanogandolfo/" target ="_blank">Stefano W. Gandolfo</a></p>      
			      			</div>
			      		</div>		

			      		<!--
			      		<div class="row">
			      			<div class="col-6" style="text-align:right;border-right: solid 1px #1d1d1d;">
			      				<p><strong>Website:</strong></p>
			      			</div>
			      			<div class="col-6" style="text-align:left;">
			      				<p><a href="https://stwc.syncly.it" target ="_blank">https://stwc.syncly.it</a></p>
			      			</div>
			      		</div>	
						-->

			      		<div class="row">
			      			<div class="col-6" style="text-align:right;border-right: solid 1px #1d1d1d;">
			      				<p><strong>Support:</strong></p>
			      			</div>
			      			<div class="col-6" style="text-align:left;">
			      				<p><a href="<?php 
        echo  stwc_settings::STWC_SUPPORT_URL ;
        ?>" target="_blank">Discord Channel</a></p>
			      			</div>
			      		</div>			
			      		
			      		<div class="row">
			      			<div class="col-6" style="text-align:right;border-right: solid 1px #1d1d1d;">
			      				<p><strong>Translators:</strong></p>
			      			</div>
			      			<div class="col-6" style="text-align:left;">
			      				<p><i>We are looking for translators, please find the details on our Discord Channel if you can help.</i></p>
			      			</div>
			      		</div>			

			      		<div class="row">
			      			<div class="col-6" style="text-align:right;border-right: solid 1px #1d1d1d;">
			      				<p><strong>Contributors:</strong></p>
			      			</div>
			      			<div class="col-6" style="text-align:left;">
			      				<p><i>We are looking also for contributors that could suggest new features and see them realized at lightfast speed.</i></p>
			      			</div>
			      		</div>						      					      			      		      		
					</div>			     
			    </div>				
			   </div>
			</div>
		</div>
	<?php 
    }
    
    public function create_free_page()
    {
        $this->settings_options = get_option( 'stwc-settings' );
        ?>		
		<script type="text/javascript" src="<?php 
        echo  STWC_URL ;
        ?>/admin/js/stwc_free.js"></script>		
		<link href="<?php 
        echo  STWC_URL ;
        ?>/admin/css/style.css" rel="stylesheet" type="text/css">
		<link href="<?php 
        echo  STWC_URL ;
        ?>/admin/css/bootstrap.min.css" rel="stylesheet" type="text/css">

		<div class="wrap">
			<div class='container' style='max-width: 100%;background-color: #f1f1f1 !important; border:solid 1px #3550a0;'>
				<div class='row'>
					<div class='col-12' style="background-color: #f1f1f1">
						<h2>Basic Options</h2>								
						<p style="font-size:16px;padding-bottom:20px;">Kickstart your e-commerce with these basic tools that every shop should have. Have a cool function that you want to see? Drop us a line in Discord.</p>
						<?php 
        settings_errors();
        ?>
					</div>
				</div>
			
				<div class='row'>
					<?php 
        require_once STWC_PATH . 'includes/stwc__wp_template.php';
        ?>
					<form method="post" action="options.php">
						<?php 
        echo  "<div class='container' style='max-width: 100%;'><div class='row'><div class='col-6'>" ;
        settings_fields( 'stwc-default' );
        //do_settings_sections( 'stwc-free' );
        stwc_free_settings_sections();
        echo  "</div></div><div class='row'><div class='col-12'>" ;
        submit_button();
        echo  "</div></div></div>" ;
        ?>
					</form>			
				</div>
			</div>					
		</div>
	<?php 
    }
    
    public function create_prot_page()
    {
    }
    
    public function create_deal_page()
    {
        ?>				
		<link href="<?php 
        echo  STWC_URL ;
        ?>/admin/css/style.css" rel="stylesheet" type="text/css">
		<link href="<?php 
        echo  STWC_URL ;
        ?>/admin/css/bootstrap.min.css" rel="stylesheet" type="text/css">

		<div class="wrap">
	    	<div class="container" style="max-width: 100%;">
	    		<div class="row">
	    			<div class="col-12">
						<h2><strong style="color: #FCB214;margin-bottom:20px;">Upgrade Deal</strong></h2>				    				
						<p style="font-size:16px;padding-bottom:10px;">You, better than anyone, know that everyone loves coupon codes. Here is the current Upgrade Deal for you:<br/>
						Simply join our <a href="<?php 
        echo  stwc_settings::STWC_SUPPORT_URL ;
        ?>" target="_blank">Discord Channel</a> and you will instantly receive a <strong>-10% coupon</strong> valid on all plans.</p>
						
						<a href="<?php 
        echo  stwc_settings::STWC_SUPPORT_URL ;
        ?>" role="button" target="_blank"><img src="<?php 
        echo  STWC_URL ;
        ?>/admin/images/discord-deal.png" alt="Discord Upgrade Deal" style="width:650px;max-width:650px;"></a>
					</div>
	      		</div>
	      	</div>
		</div>
	<?php 
    }
    
    public function create_bulk_page()
    {
        ?>				
		<link href="<?php 
        echo  STWC_URL ;
        ?>/admin/css/style.css" rel="stylesheet" type="text/css">
		<link href="<?php 
        echo  STWC_URL ;
        ?>/admin/css/bootstrap.min.css" rel="stylesheet" type="text/css">

		<div class="wrap">
	    	<div class="container" style="max-width: 100%;">
	    		<div class="row">
	    			<div class="col-9">
						<h2 style="color: rgb(0, 171, 240);margin-bottom:20px;">Bulk Coupons</h2>				    				
						<p style="font-size:16px;padding-bottom:10px;">Bulk Coupons is an upcoming feature that will allow you to generate <b>thousands</b> of <u>"easy to remember but hard to guess"</u> codes and WooCommerce coupons. I often use this feature for my customers to easily generate codes for <a href="http://fbuy.me/v/elnath78">AppSumo launch</a> and other purposes where you need a lot of codes.</p>
						<p>At the moment there is no ETA for when this will be available, however you are welcome to <a href="<?php 
        echo  stwc_settings::STWC_SUPPORT_URL ;
        ?>" target="_blank">up vote it in the roadmap</a> to speed this up.</p><br/>
						<p style="font-weight: bold;text-decoration: underline;">What we know so far:</p>		
						<ol>
							<li>There will be one additional <span style="color:#be132d;">Account Tier</span></li>
							<li>Pro users will <u>have access</u> to this functionality</li>
							<li>The functionality will be metered per year</li>
							<li>Lifetime users will have metered reset every year</li>
							<li>Pro users will receive this functionality before</li>
							<li>Generate up to 25.000 codes / year with <span style="color:#be132d;">Tier 3</span> license</li>
						</ol>				
					</div>
	      		</div>
	      	</div>
		</div>
	<?php 
    }
    
    public function settings_page_init()
    {
        register_setting(
            'stwc-default',
            // option_group
            'stwc-settings',
            // option_name
            array( $this, 'settings_sanitize' )
        );
        add_settings_section(
            'stwc_ft_saba_section',
            // id
            'Removes On Sale Badge',
            // title
            array( $this, 'stwc_ft_saba_section_info' ),
            // callback
            'stwc-free'
        );
        add_settings_section(
            'stwc_ft_oosn_section',
            // id
            'Out of Stock Notice',
            // title
            array( $this, 'stwc_ft_oosn_section_info' ),
            // callback
            'stwc-free'
        );
        add_settings_section(
            'stwc_ft_dipe_section',
            // id
            'Display Discount Percentage',
            // title
            array( $this, 'stwc_ft_dipe_section_info' ),
            // callback
            'stwc-free'
        );
        add_settings_section(
            'stwc_ft_prsc_section',
            // id
            'Price Shortcode by ID',
            // title
            array( $this, 'stwc_ft_prsc_section_info' ),
            // callback
            'stwc-free'
        );
        // FIELDS SECTION
        add_settings_field(
            'stwc_ft_oosn_0',
            // id
            'Enable<br><span style="font-size:80%;">(<i>Add CSS to swtc-onsale class</i>)</span>',
            // title
            array( $this, 'stwc_ft_oosn_0_callback' ),
            // callback
            'stwc-free',
            // page
            'stwc_ft_oosn_section'
        );
        add_settings_field(
            'stwc_ft_oosn_notice_1',
            // id
            'Text to show<br><span style="font-size:80%;">(<i>Example: Sold Out!</i>)</span>',
            // title
            array( $this, 'stwc_ft_oosn_notice_1_callback' ),
            // callback
            'stwc-free',
            // page
            'stwc_ft_oosn_section'
        );
        add_settings_field(
            'stwc_ft_dipe_7',
            // id
            'Enable<br><span style="font-size:80%;">(<i>Add CSS to swtc-sale-perc class</i>)</span>',
            // title
            array( $this, 'stwc_ft_dipe_7_callback' ),
            // callback
            'stwc-free',
            // page
            'stwc_ft_dipe_section'
        );
        add_settings_field(
            'stwc_ft_saba_8',
            // id
            'Enable',
            // title
            array( $this, 'stwc_ft_saba_8_callback' ),
            // callback
            'stwc-free',
            // page
            'stwc_ft_saba_section'
        );
        add_settings_field(
            'stwc_ft_prsc_2',
            // id
            'Enable',
            // title
            array( $this, 'stwc_ft_prsc_2_callback' ),
            // callback
            'stwc-free',
            // page
            'stwc_ft_prsc_section'
        );
    }
    
    public function settings_sanitize( $input )
    {
        $sanitary_values = array();
        //Out of Stock Notice
        if ( isset( $input['stwc_ft_oosn_0'] ) ) {
            $sanitary_values['stwc_ft_oosn_0'] = $input['stwc_ft_oosn_0'];
        }
        if ( isset( $input['stwc_ft_oosn_notice_1'] ) ) {
            $sanitary_values['stwc_ft_oosn_notice_1'] = sanitize_text_field( $input['stwc_ft_oosn_notice_1'] );
        }
        //--validation
        
        if ( isset( $input['stwc_ft_oosn_0'] ) && empty($sanitary_values['stwc_ft_oosn_notice_1']) ) {
            //if (empty($sanitary_values['stwc_ft_oosn_notice_1'])){
            add_settings_error( 'stwc-validate', 'invalid_stwc_ft_oosn_notice_1', 'Out of Stock Notice: [Text to Show] cannot be empty' );
            return false;
            //}
        }
        
        // End Out of Stock
        if ( isset( $input['stwc_ft_dipe_7'] ) ) {
            $sanitary_values['stwc_ft_dipe_7'] = $input['stwc_ft_dipe_7'];
        }
        if ( isset( $input['stwc_ft_saba_8'] ) ) {
            $sanitary_values['stwc_ft_saba_8'] = $input['stwc_ft_saba_8'];
        }
        if ( isset( $input['stwc_ft_capa_9'] ) ) {
            $sanitary_values['stwc_ft_capa_9'] = $input['stwc_ft_capa_9'];
        }
        if ( isset( $input['stwc_ft_prsc_2'] ) ) {
            $sanitary_values['stwc_ft_prsc_2'] = $input['stwc_ft_prsc_2'];
        }
        return $sanitary_values;
    }
    
    public function stwc_ft_oosn_section_info()
    {
        echo  "<p style='font-size: 16px;'>When a product with stock management is out of stock (quantity 0) WooCommerce doesn't show any notice in the shop page. In some cases, it is convenient to tell the customers that \r\n\t\ta product is out of stock, depending on your business logic. If you enable this option you can show a custom message, make sure to use CSS to style it appropriately.</p>" ;
    }
    
    public function stwc_ft_dipe_section_info()
    {
        echo  "<p style='font-size: 16px;'>Display the % of price reduction of an item. For items with variants, show the max percentage inside the item. You can copy this <span class='swtc-sale-perc'>CSS</span> for example.</p>" ;
    }
    
    public function stwc_ft_saba_section_info()
    {
        echo  "<p style='font-size: 16px;'>Removes the 'on sale' badge on discounted items. You can use this in combination with <i>Display Discount Percentage</i> to tell your customers the product is on sale and by how much is the discount.</p>" ;
    }
    
    public function stwc_ft_prsc_section_info()
    {
        echo  "<p style='font-size: 16px;'>Allow you to use WooCommerce shortcode to show the item price, looking it up by item ID.</p>" ;
    }
    
    public function stwc_ft_csco_section_info()
    {
    }
    
    public function stwc_ft_capa_section_info()
    {
    }
    
    public function stwc_ft_emca_section_info()
    {
    }
    
    public function stwc_ft_gdpr_section_info()
    {
    }
    
    public function stwc_ft_usro_section_info()
    {
    }
    
    public function stwc_ft_piva_section_info()
    {
    }
    
    public function stwc_ft_oosn_0_callback()
    {
        printf( '<input type="checkbox" name="stwc-settings[stwc_ft_oosn_0]" id="stwc_ft_oosn_0" value="stwc_ft_oosn_0" %s> <label for="stwc_ft_oosn_0">Enable Out of Stock notice on Out-of-Stock items that have Stock Management</label>', ( isset( $this->settings_options['stwc_ft_oosn_0'] ) && $this->settings_options['stwc_ft_oosn_0'] === 'stwc_ft_oosn_0' ? 'checked' : '' ) );
    }
    
    public function stwc_ft_oosn_notice_1_callback()
    {
        printf( '<input class="regular-text" type="text" name="stwc-settings[stwc_ft_oosn_notice_1]" id="stwc_ft_oosn_notice_1" value="%s">', ( isset( $this->settings_options['stwc_ft_oosn_notice_1'] ) ? esc_attr( $this->settings_options['stwc_ft_oosn_notice_1'] ) : '' ) );
    }
    
    public function stwc_ft_dipe_7_callback()
    {
        printf( '<input type="checkbox" name="stwc-settings[stwc_ft_dipe_7]" id="stwc_ft_dipe_7" value="stwc_ft_dipe_7" %s> <label for="stwc_ft_dipe_7">Display Discount Percentage</label>', ( isset( $this->settings_options['stwc_ft_dipe_7'] ) && $this->settings_options['stwc_ft_dipe_7'] === 'stwc_ft_dipe_7' ? 'checked' : '' ) );
    }
    
    public function stwc_ft_saba_8_callback()
    {
        printf( '<input type="checkbox" name="stwc-settings[stwc_ft_saba_8]" id="stwc_ft_saba_8" value="stwc_ft_saba_8" %s> <label for="stwc_ft_saba_8">Removes On Sale Badge</label>', ( isset( $this->settings_options['stwc_ft_saba_8'] ) && $this->settings_options['stwc_ft_saba_8'] === 'stwc_ft_saba_8' ? 'checked' : '' ) );
    }
    
    public function stwc_ft_prsc_2_callback()
    {
        printf( '<input type="checkbox" name="stwc-settings[stwc_ft_prsc_2]" id="stwc_ft_prsc_2" value="stwc_ft_prsc_2" %s> <label for="stwc_ft_prsc_2">Enable Price Shortcode by Item ID</label>', ( isset( $this->settings_options['stwc_ft_prsc_2'] ) && $this->settings_options['stwc_ft_prsc_2'] === 'stwc_ft_prsc_2' ? 'checked' : '' ) );
    }
    
    public function stwc_ft_csco_3_callback()
    {
    }
    
    public function stwc_ft_csco_size_4_callback()
    {
    }
    
    public function stwc_ft_csco_name_5_callback()
    {
    }
    
    public function stwc_ft_csco_attribute_name_6_callback()
    {
    }
    
    public function stwc_ft_capa_9_callback()
    {
    }
    
    public function stwc_ft_emca_10_callback()
    {
    }
    
    public function stwc_ft_gdpr_11_callback()
    {
    }
    
    public function stwc_ft_gdpr_text_12_callback()
    {
    }
    
    public function stwc_ft_gdpr_link_text_13_callback()
    {
    }
    
    public function stwc_ft_gdpr_privacy_page_14_callback()
    {
    }
    
    public function stwc_ft_usro_15_callback()
    {
    }
    
    public function stwc_ft_usro_product_id_16_callback()
    {
    }
    
    public function stwc_ft_usro_role_17_callback()
    {
    }
    
    public function stwc_ft_piva_18_callback()
    {
    }
    
    public function stwc_ft_piva_label_19_callback()
    {
    }
    
    public function stwc_ft_piva_placeholder_20_callback()
    {
    }

}